﻿Imports GTA
Imports GTA.Math
Imports GTA.Native
Imports GTA.UI
Imports System.Windows.Forms
Imports System.Drawing

Public Class Enumerator
    Inherits Script

    Sub New()
        Interval = 0
    End Sub

    Dim boolnow = False
    Dim missle As Prop
    Dim externCam As Camera
    Dim raytrace As RaycastResult

    Dim missle_start_height As Single = 100.0!
    Private Sub Enumerator_KeyDown(sender As Object, e As KeyEventArgs) Handles Me.KeyDown
        If NC_Am_I_Aiming() Then
            If boolnow = False Then
                UI.ShowSubtitle("Press O for Jericho Missle", 0.2)
                If e.KeyCode = Keys.O Then
                    raytrace = Cam_Raycast_Forward(10000.0)
                    If raytrace.DitHitAnything Then
                        missle = World.CreateProp("w_lr_rpg_rocket", New Vector3(raytrace.HitCoords.X, raytrace.HitCoords.Y, (raytrace.HitCoords.Z + missle_start_height)), False, False)
                        externCam = World.CreateCamera(New Vector3(raytrace.HitCoords.X, raytrace.HitCoords.Y, (raytrace.HitCoords.Z + missle_start_height)), New Vector3(-90, 0, Game.Player.Character.Rotation.Z - 180), 220.0!)
                        World.RenderingCamera = externCam
                        externCam.AttachTo(missle, New Vector3(missle.Model.GetDimensions.X / 2, missle.Model.GetDimensions.Y / 2, missle.Model.GetDimensions.Z - 10))
                        boolnow = True
                    End If
                End If
            End If
        End If
    End Sub

    Sub Ontick(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Tick
        If boolnow = True Then
            missle.ApplyForce(New Vector3(0.0!, 0.0!, -100.0!))
            missle.Position = New Vector3(raytrace.HitCoords.X, raytrace.HitCoords.Y, missle.Position.Z)
            'MISSLE PAUSING IN MID AIR BUG IS HERE////////// 
            If Native.Function.Call(Of Boolean)(Native.Hash.HAS_ENTITY_COLLIDED_WITH_ANYTHING, missle) Or missle.Velocity.Z > 0.001 Or missle.Position.Z < World.GetGroundHeight(New Vector3(raytrace.HitCoords.X, raytrace.HitCoords.Y, raytrace.HitCoords.Z)) + 2 Then '<<<<<<<<<<<<<<<
                For i = 0 To 50
                    World.AddExplosion(missle.Position, ExplosionType.ExplosionWithFire2, 55.0!, 4.5!)
                Next
                World.RenderingCamera = Nothing
                externCam.Destroy()
                missle.MarkAsNoLongerNeeded()
                missle.Delete()
                boolnow = False
            End If
            End If
    End Sub
    Public Function RotToDir(ByVal Rot As Vector3) As Vector3
        Try
            Dim z As Double = Rot.Z : Dim retz As Double = z * 0.0174532924F
            Dim x As Double = Rot.X : Dim retx As Double = x * 0.0174532924F
            Dim absx As Double = System.Math.Abs(System.Math.Cos(retx))
            Return New Vector3(-System.Math.Sin(retz) * absx, System.Math.Cos(retz) * absx, System.Math.Sin(retx))
        Catch : End Try
    End Function

    Public Function Cam_Raycast_Forward(ByVal distance As Single) As RaycastResult
        Try
            Dim camera_position As Vector3 = NC_Get_Cam_Position() + RotToDir(Native.Function.Call(Of Vector3)(Hash.GET_GAMEPLAY_CAM_ROT, 0)) * distance
            Dim ray As RaycastResult = World.Raycast(NC_Get_Cam_Position(), camera_position, IntersectOptions.Everything)
            Return ray
        Catch : End Try
    End Function

    Public Function NC_Get_Cam_Position() As Vector3
        Try
            Return Native.Function.Call(Of Vector3)(Hash.GET_GAMEPLAY_CAM_COORD)
        Catch : End Try
        Return New Vector3(0, 0, 0)
    End Function

    Public Function NC_Am_I_Aiming() As Boolean
        Try
            Return Native.Function.Call(Of Boolean)(Hash.IS_PLAYER_FREE_AIMING, Game.Player)
        Catch : End Try
        Return False
    End Function
End Class
